--- fedora-security-guide_7_Zip_fr.po	2011-09-24 21:18:00.000000000 +0000
+++ fedora-security-guide_7_Zip_fr1.po	2011-09-25 09:56:16.000000000 +0000
@@ -1,6 +1,6 @@
 # AUTHOR <EMAIL@ADDRESS>, YEAR.
 # 
-# Translators:
+# Translators: Antoine POUILLAUDE
 msgid ""
 msgstr ""
 "Project-Id-Version: Fedora Security Guide\n"
@@ -13,11 +13,12 @@
 "Content-Transfer-Encoding: 8bit\n"
 "Language: fr\n"
 "Plural-Forms: nplurals=2; plural=(n > 1)\n"
+"Report-Msgid-Bugs-To: https://bugzilla.redhat.com/\n"
 
 #. Tag: title
 #, no-c-format
 msgid "7-Zip Encrypted Archives"
-msgstr ""
+msgstr "Archives cryptées 7-zip"
 
 #. Tag: para
 #, no-c-format
@@ -28,12 +29,17 @@
 "when you need to move data between multiple computers that use varying "
 "operating systems (i.e. Linux at home, Windows at work) and you want a "
 "portable encryption solution."
-msgstr ""
+msgstr "<ulink url=\"http://www.7-zip.org/\">7-Zip</ulink> est un outil de compression de fichiers,"
+" dernière génération, capable aussi d'utiliser un cryptage (AES-256) "
+"puissant pour protéger le contenu de vos archives. Ceci est extremement utile "
+"lorsque vous avez besoin de déplacer des données entre de nombreux ordinateurs qui utilisent différents "
+"sytèmes d'exploitations (i.e. Linux chez vous, Windows au travail) et lorsque vous voulez une "
+"solution de cryptage portable."
 
 #. Tag: title
 #, no-c-format
 msgid "7-Zip Installation in Fedora"
-msgstr ""
+msgstr "Installation de 7-Zip dans Fedora"
 
 #. Tag: para
 #, no-c-format
@@ -41,34 +47,37 @@
 "7-Zip is not a base package in Fedora, but it is available in the software "
 "repository. Once installed, the package will update alongside the rest of "
 "the software on the computer with no special attention necessary."
-msgstr ""
+msgstr "7-Zip n'est pas un package de base dans Fedora, mais il est disponible dans le répertoire "
+"de logiciels. Une fois installé, le package se mettra à jour automatiquement en même temps que "
+"le reste du logiciel."
 
 #. Tag: title
 #, no-c-format
 msgid "Step-by-Step Installation Instructions"
-msgstr ""
+msgstr "Guide d'installation étape par étape"
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Open a Terminal: <code>Click ''Applications'' -&gt; ''System Tools'' -&gt; "
 "''Terminal''</code>"
-msgstr ""
+msgstr "Ouvrez un Terminal : <code>Click ''Applications'' -&gt; ''Outils Système'' -&gt; "
+"''Terminal''</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Install 7-Zip with sudo access: <code>sudo yum install p7zip</code>"
-msgstr ""
+msgstr "Installez 7-Zip en mode sudo : <code>sudo yum install p7zip</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Close the Terminal: <code>exit</code>"
-msgstr ""
+msgstr "Fermez le Terminal : <code>exit</code>"
 
 #. Tag: title
 #, no-c-format
 msgid "Step-by-Step Usage Instructions"
-msgstr ""
+msgstr "Guide d'utilisation étapa par étape"
 
 #. Tag: para
 #, no-c-format
@@ -78,20 +87,26 @@
 "unaltered. This technique can be applied to any directory or file you have "
 "access to on the filesystem."
 msgstr ""
+"En suivant ces instructions vous allez compresser et crypter votre dossier "
+"\"Documents\". Votre dossier \"Documents\" original ne sera pas altéré. Cette "
+"technique peut être appliquée sur tous les dossiers et fichiers auxquels vous "
+"avez accés dans le système de fichiers."
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Open a Terminal:<code>Click ''Applications'' -&gt; ''System Tools'' -&gt; "
 "''Terminal''</code>"
-msgstr ""
+msgstr "Ouvrez un Terminal : <code>Click ''Applications'' -&gt; ''Outils Système'' -&gt; "
+"''Terminal''</code>""
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Compress and Encrypt: (enter a password when prompted) <code>7za a -mhe=on "
 "-ms=on -p Documents.7z Documents/</code>"
-msgstr ""
+msgstr "Compressez et cryptez : (entrez un mot de passe lorsque vous y êtes invité) <code>7za a -mhe=on "
+"-ms=on -p Documents.7z Documents/</code>"
 
 #. Tag: para
 #, no-c-format
@@ -99,29 +114,31 @@
 "The \"Documents\" directory is now compressed and encrypted. The following "
 "instructions will move the encrypted archive somewhere new and then extract "
 "it."
-msgstr ""
+msgstr "Le dossier \"Documents\" est à présent compressé et crypté. Les instructions "
+"suivantes vont déplacer et extraire l'archive cryptée dans un nouvel endroit."
 
 #. Tag: para
 #, no-c-format
 msgid "Create a new directory: <code>mkdir newplace</code>"
-msgstr ""
+msgstr "Créez un nouveau dossier : <code>mkdir newplace</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Move the encrypted file: <code>mv Documents.7z newplace</code>"
-msgstr ""
+msgstr "Déplacez le fichier crypté : <code>mv Documents.7z newplace</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Go to the new directory: <code>cd newplace</code>"
-msgstr ""
+msgstr "Allez dans le nouveau dossier : <code>cd newplace</code>"
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Extract the file: (enter the password when prompted) <code>7za x "
 "Documents.7z</code>"
-msgstr ""
+msgstr "Extrayez le fichier : (entre le mots de passe quand vous y êtes invité) <code>7za x "
+"Documents.7z</code>"
 
 #. Tag: para
 #, no-c-format
@@ -130,22 +147,26 @@
 "instructions will clean up all the prior steps and restore your computer to "
 "its previous state."
 msgstr ""
+"L'archive est maintenant extraite dans le nouveau dossier. Les instructions "
+"suivantes vont effacer les étapes précedentes et restaurer votre ordinateur "
+"à son état antérieur."
 
 #. Tag: para
 #, no-c-format
 msgid "Go up a directory: <code>cd ..</code>"
-msgstr ""
+msgstr "Remontez d'un répertoire : <code>cd ..</code>"
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Delete the test archive and test extraction: <code>rm -r newplace</code>"
 msgstr ""
+"Supprimez l'archive et l'extraction test : <code>rm -r newplace</code>"
 
 #. Tag: title
 #, no-c-format
 msgid "Things of note"
-msgstr ""
+msgstr "Notes"
 
 #. Tag: para
 #, no-c-format
@@ -154,6 +175,9 @@
 "need to use your 7-Zip files on those platforms you will need to install the"
 " appropriate version of 7-Zip on those computers. See the 7-Zip <ulink "
 "url=\"http://www.7-zip.org/download.html\">download page</ulink>."
-msgstr ""
+msgstr "7-Zip n'est pas livré par défaut avec Microsoft Windows ou Mac OS X. Si vous "
+"avez besoin d'utiliser votre fichier 7-Zip sur ces sytèmes vous aurez à installer la version "
+"approprié de 7-Zip sur ces ordinateurs. Allez sur la <ulink url=\"http://www.7-zip.org/download.html\">"
+"page de téléchargement</ulink> de 7-Zip."
 
 